#
# spec file for package ucode-intel
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           ucode-intel
Version:        20180312
Release:        lp150.3.1
Summary:        Microcode Updates for Intel x86/x86-64 CPUs
License:        SUSE-Firmware
Group:          Hardware/Other
BuildRequires:  suse-module-tools
#License is: Intel Software License Agreement
Url:            https://downloadcenter.intel.com/download/27591/Linux-Processor-Microcode-Data-File
Source0:        https://downloadmirror.intel.com/27591/eng/microcode-%{version}.tgz
Source2:        LICENSE
Supplements:    modalias(x86cpu:vendor%3A0000%3Afamily%3A*%3Amodel%3A*%3Afeature%3A*)
# new method ... note that only 1 : might be present, otherwise libzypp misinterprets it.
Supplements:    modalias(cpu:type%3Ax86*ven0000*)
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  iucode-tool
Requires(post): coreutils
Requires(postun): coreutils
ExclusiveArch:  %ix86 x86_64

%description
This package contains the microcode update blobs for Intel x86 and x86-64 CPUs.

%prep
%setup -q -c intel-ucode
cp %{SOURCE2} .

%build
#it is closed source.. nothing to build.

%install
mkdir -p %{buildroot}/lib/firmware/intel-ucode
/usr/sbin/iucode_tool -vvv --write-firmware="%{buildroot}/lib/firmware/intel-ucode" microcode.dat

%post
%{?regenerate_initrd_post}

%postun
%{?regenerate_initrd_post}

%posttrans
%{?regenerate_initrd_posttrans}

%files
%defattr(-,root,root)
%doc LICENSE
/lib/firmware/intel-ucode/

%changelog
* Fri Apr 13 2018 meissner@suse.com
- next try to fix CPU detection modalias... The modalias
  can only have 1 : (bsc#1084687)
* Wed Mar 21 2018 meissner@suse.com
- fix the CPU detection modalias to meet current kernel logic.
  (bsc#1084687)
* Wed Mar 14 2018 meissner@suse.com
- Updated to microcode version: 20180312 (bsc#1085207 CVE-2017-5715)
  - - New Platforms --
  BDX-DE EGW A0 6-56-5:10 e000009
  SKX B1 6-55-3:97 1000140
  - - Updates --
  SNB D2 6-2a-7:12 29->2d
  JKT C1 6-2d-6:6d 619->61c
  JKT C2 6-2d-7:6d 710->713
  IVB E2 6-3a-9:12 1c->1f
  IVT C0 6-3e-4:ed 428->42c
  IVT D1 6-3e-7:ed 70d->713
  HSW Cx/Dx 6-3c-3:32 22->24
  HSW-ULT Cx/Dx 6-45-1:72 20->23
  CRW Cx 6-46-1:32 17->19
  HSX C0 6-3f-2:6f 3a->3c
  HSX-EX E0 6-3f-4:80 0f->11
  BDW-U/Y E/F 6-3d-4:c0 25->2a
  BDW-H E/G 6-47-1:22 17->1d
  BDX-DE V0/V1 6-56-2:10 0f->15
  BDW-DE V2 6-56-3:10 700000d->7000012
  BDW-DE Y0 6-56-4:10 f00000a->f000011
  SKL-U/Y D0 6-4e-3:c0 ba->c2
  SKL R0 6-5e-3:36 ba->c2
  KBL-U/Y H0 6-8e-9:c0 62->84
  KBL B0 6-9e-9:2a 5e->84
  CFL D0 6-8e-a:c0 70->84
  CFL U0 6-9e-a:22 70->84
  CFL B0 6-9e-b:02 72->84
  SKX H0 6-55-4:b7 2000035->2000043
* Mon Mar  5 2018 crrodriguez@opensuse.org
- intel-microcode2ucode.c replaced by better maintained and
  feature rich iucode_tool package, add it to buildrequires.
* Thu Nov 23 2017 trenn@suse.de
- Update to microcode version: 20171117 (bsc#1068839)
  - - New Platforms --
  CFL U0 (06-9e-0a:22) 70
  CFL B0 (06-9e-0b:2) 72
  SKX H0 (06-55-04:b7) 2000035
  GLK B0 (06-7a-01:1) 1e
  APL Bx (06-5c-09:3) 2c
  - - Updates --
  KBL Y0 (06-8e-0a:c0) 66->70
* Wed Jul 19 2017 astieger@suse.com
- Remove code in intel-microcode2ucode.c that refers to
  GenuineIntel.bin , previously in binary blob package.
* Tue Jul 18 2017 trenn@suse.de
- Remove binary blob package again. This was intended to be used
  by linuxrc, but the firmware files can simply be concatenated.
* Thu Jul 13 2017 trenn@suse.de
- Update to version 20170707 (bsc#1048133, bsc#1043358):
  KBL H0 (06-8e-09:c0) 62
  KBL Y0 (06-8e-0a:c0) 66
  KBL B0 (06-9e-09:2a) 5e
  SKX H0 (06-55-04:97) 2000022
* Tue May 16 2017 idonmez@suse.com
- Update to version 20170511:
  BDX-ML B0/M0/R0 (06-4f-01:ef) b00001f->b000021
  Skylake D0 (06-4e-03:c0) 9e->ba
  Broadwell ULT/ULX E/F-step (06-3d-04:c0) 24->25
  ULT Cx/Dx (06-45-01:72) 1f->20
  Crystalwell Cx (06-46-01:32) 16->17
  Broadwell Halo E/G-step (06-47-01:22) 16->17
  HSX EX E0 (06-3f-04:80) d->f
  Skylake R0 (06-5e-03:36) 9e->ba
  Haswell Cx/Dx (06-3c-03:32) 20->22
  HSX C0 (06-3f-02:6f) 39->3a
* Mon Dec  5 2016 crrodriguez@opensuse.org
- Update to version 20161104.
* Thu Jul 21 2016 trenn@suse.de
- Update to version 20160714.
- Should fix bsc#987358, a bug which got introduced with the last
  release.
- Should finally fix "Intel Skylake bug" (bnc#993639), previous
  releases since Jan 2016 may or may not have completely fixed it.
* Thu Jun 23 2016 crrodriguez@opensuse.org
- Update to version 20160607, no changelog available
* Thu Dec 10 2015 tiwai@suse.de
- Fix dependency on coreutils for initrd macros (boo#958562)
- Call missing initrd macro at postun (boo#958562)
* Tue Nov 10 2015 fvogt@suse.com
- Fix Url and Source0
- Add GenuineIntel.bin to ucode-intel-blob
* Tue Nov 10 2015 p.drouand@gmail.com
- Update to version 20151106
  * No changelog available
- Use download Url as source
* Mon Nov  2 2015 fvogt@suse.com
- Add ucode-intel-blob subpackage to get the full microcode.dat
    directly
* Thu Mar 19 2015 crrodriguez@opensuse.org
- Update to microcode 20150121.
* Wed Jan 21 2015 mpluskal@suse.com
- Pre require coreutils (bnc#914169).
* Fri Sep 19 2014 trenn@suse.de
- Do not try to reload/update microcode at runtime after package
  installation. Only supported way of updating microcode is via
  early microcode update via initrd. bnc#896736
* Wed Sep 17 2014 trenn@suse.de
- Update to Intel microcode version 20140624 (bnc#896736, fate#317896)
  This microcode disables lock elision on CPUs which are known to
  not work reliable with this feature
* Wed Jul  2 2014 tiwai@suse.de
- Update to Intel microcode version 20140624 (bnc#885213)
* Fri Jun 13 2014 trenn@suse.de
- Delete mkinitrd scripts. This is done via %%rpm regenerate_initrd_* macros
  (bnc#894160)
* Mon May  5 2014 trenn@suse.de
- Update to Intel microcode version 20140430 (bnc#876073)
* Fri Apr  4 2014 mmarek@suse.cz
- Regenerate the initrd in %%posttrans (fate#313506)
* Tue Feb 11 2014 idonmez@suse.com
- ucode 20140122, no changelog available.
* Tue Dec 10 2013 trenn@suse.de
- Loading firmware needs udev to be running
* Mon Dec  2 2013 trenn@suse.de
- Add mkinitrd script to add Intel microcode to initrd.
  This is needed because microcode driver is built in or gets loaded
  automatically via udev early. Therefore the microcode has to be available
  in initrd already.
  This must not be mixed up with early micorcode loading. This feature will
  not be implemented via mkinitrd. Dracut is doing early microcode loading.
- bnc#847158
- mkinitrd scripts:
  - mkinitrd_setup-intel_microcode.sh
    Adding microcode to the initrd
  - mkinitrd_boot-intel_microcode.sh
    Triggering the reload at boot
* Mon Nov 25 2013 trenn@suse.de
- Correct Supplements string so that the package gets correctly installed
  on machines with Intel CPUs
  bnc#847158
* Sun Sep 22 2013 crrodriguez@opensuse.org
- ucode 20130906, no changelog available.
* Fri Aug 30 2013 crrodriguez@opensuse.org
- ucode 20130808, as usual, no changelog available.
* Thu Jul 25 2013 aj@suse.com
- Run spec-cleaner
* Wed Jul 24 2013 jeffm@suse.com
- Initial packaging. Moved microcode from microctl_ctl package.
